"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("simpleutils");
const basicutil_1 = require("basicutil");
const componentPage_1 = require("../../../../page/componentPage");
const componentGeneric_1 = require("../componentGeneric");
class ComponentRouter extends componentGeneric_1.ComponentGeneric {
    constructor(geneticCode) {
        super(geneticCode);
        this.pages = {};
        this.routerName = geneticCode.routerName;
        this.suffix = geneticCode.suffix;
        this.main = geneticCode.main;
        this.go = false;
        this.init(geneticCode.nextName);
        // console.log(father, pageName, routerName, nextName, suffix, main);
    }
    init(nextName) {
        this.pageName = nextName;
    }
    getNormalizedName(newName) {
        if (newName !== undefined &&
            (newName.indexOf(this.suffix) === -1) &&
            this.suffix !== undefined) {
            newName = newName + this.suffix;
        }
        return newName;
    }
    initPage(pageName) {
        this.go = true;
        if (this.pages[pageName] === undefined) {
            this.pages[pageName] = new componentPage_1.ComponentPage({ father: this, file: pageName });
        }
        else {
            if (this.pages[pageName].getChildrenLength() === 0 && this.pages[pageName].getUnknown() === true) {
                this.nextName = 'unknown';
                this.pages[this.nextName].setPage();
            }
            else {
                this.pages[pageName].setPage();
            }
        }
    }
    setState() {
    }
    getNextName() {
        return this.nextName;
    }
    getPages() {
        return this.pages;
    }
    toGo() {
        return this.go;
    }
    went() {
        this.go = false;
    }
    set pageName(newName) {
        newName = this.getNormalizedName(newName);
        let cookie = basicutil_1.Util.getInstance().getCookie(this.routerName);
        if (this.currentName === undefined ||
            this.currentName !== newName) {
            this.nextName = newName;
            if (newName) {
                this.initPage(newName);
            }
            else if (cookie !== '') {
                this.pageName = cookie;
            }
            else {
                this.pageName = this.main;
            }
            this.updateName();
        }
    }
    get pageName() {
        return this.currentName;
    }
    refresh() {
        // console.log('refreshNotification:');
        this.pages = {};
        let pageName = this.currentName;
        this.currentName = undefined;
        this.pageName = pageName;
    }
    updateFailed(data, page) {
        // console.log('updateFailed:', data);
        page.setUnknown(true);
        this.pageName = 'unknown';
    }
    updateName() {
        this.currentName = this.nextName;
        this.setState();
        basicutil_1.Util.getInstance().clearCookie(this.routerName);
    }
}
exports.ComponentRouter = ComponentRouter;
ComponentRouter.addConstructor(ComponentRouter);
//# sourceMappingURL=componentRouter.js.map